// BigNumberDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "BigNumber.h"
#include "BigNumberDlg.h"
#include "Registry.h"
#include "vc6.h"
#include <math.h>
#include <afxpriv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////

#define REGISTRY_DISTO_SUBKEY	_T("Software\\PMS AG Photo Mess Systeme\\DistoMonitor")
#define KEY_OFFSET1				_T("Offset1")
#define KEY_OFFSET2				_T("Offset2")


//	Makros fr elegantes Lesen und schreiben.
//	Es mssen folgende Deklarationen vor Aufruf dieser Makros gemacht sein:
//
//	CRegistry aReg;
//	CString  aString;
	

#define READ_INT(HKey, Key,Value)		aString.Format(_T("%d"),Value);				\
										aReg.LoadKey( HKey, Key, aString);			\
										Value = _tstoi(aString)						
																				
#define READ_INT_T(HKey, Key,Value,T)	aString.Format(_T("%d"),Value);				\
										aReg.LoadKey( HKey, Key, aString);			\
										Value = (T) _tstoi(aString)						

#define READ_DOUBLE(HKey, Key,Value)	aString.Format(_T("%g"),Value);				\
										aReg.LoadKey( HKey, Key, aString);			\
										Value = _tstof(aString)						
																				
#define READ_STRING(HKey, Key,Value)	aReg.LoadKey( HKey, Key, Value)		
																				
																				
																				
#define WRITE_INT(HKey, Key,Value)		aString.Format(_T("%d"),Value);				\
										aReg.SaveKey( HKey, Key, aString)		
																				
#define WRITE_DOUBLE(HKey, Key,Value)	aString.Format(_T("%g"),Value);				\
										aReg.SaveKey( HKey, Key, aString)	
									
#define WRITE_STRING(HKey, Key,Value)	aReg.SaveKey( HKey, Key, Value)



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Verbessertes DDX_Text

#define SAVE_TEXT_SEL()	DWORD nStartChar;																\
						DWORD nEndChar;																	\
						if(bKeepSel)																	\
							::SendMessage(hWndCtrl, EM_GETSEL, (WPARAM)&nStartChar, (LPARAM)&nEndChar);

#define SET_TEXT_SEL()	if(bKeepSel)	::SendMessage(hWndCtrl,EM_SETSEL, nStartChar, nEndChar);

void DDX_Text( CDataExchange* pDX, int nIDC, double& value, const CString& rFormat, bool bKeepSel = false )
{
	HWND hWndCtrl = pDX->PrepareEditCtrl(nIDC);

	if(pDX->m_bSaveAndValidate)
	{
		TCHAR aBuffer[200];

		::GetWindowText(hWndCtrl, aBuffer, sizeof(aBuffer));
		value = atof(aBuffer);
	}
	else
	{
		CString aText;
		aText.Format(rFormat,value);
		SAVE_TEXT_SEL();
		AfxSetWindowText(hWndCtrl, aText);
		SET_TEXT_SEL();
	}
}


/////////////////////////////////////////////////////////////////////////////
// CBigNumberDlg Dialogfeld

CBigNumberDlg::CBigNumberDlg(CWnd* pParent /*=NULL*/)
	: ETSLayoutDialog(CBigNumberDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBigNumberDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bDistoStart1 = false;
	m_bDistoStart2 = false;
	m_bDistoConnected1 = false;
	m_bDistoConnected2 = false;
}

void CBigNumberDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBigNumberDlg)
	DDX_Control(pDX, IDC_STATIC_DISPLAY3, m_Display3);
	DDX_Control(pDX, IDC_STATIC_DISPLAY, m_Display1);
	DDX_Control(pDX, IDC_STATIC_DISPLAY2, m_Display2);
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_EDIT_OFFSET1, m_ReceiveWindow1.m_dOffset, "%.3f");
	DDX_Text(pDX, IDC_EDIT_OFFSET2, m_ReceiveWindow2.m_dOffset, "%.3f");
}

BEGIN_MESSAGE_MAP(CBigNumberDlg, ETSLayoutDialog)
	//{{AFX_MSG_MAP(CBigNumberDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_WM_SIZE()
	ON_EN_CHANGE(IDC_EDIT_OFFSET1, OnChangeEditOffset1)
	ON_EN_CHANGE(IDC_EDIT_OFFSET2, OnChangeEditOffset2)
	ON_EN_KILLFOCUS(IDC_EDIT_OFFSET1, OnKillfocusEditOffset1)
	ON_EN_KILLFOCUS(IDC_EDIT_OFFSET2, OnKillfocusEditOffset2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBigNumberDlg Nachrichten-Handler

BOOL CBigNumberDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	CreateRoot(VERTICAL)

		<< (pane( HORIZONTAL, GREEDY) 
				<< item ( IDC_STATIC_DISPLAY,	ALIGN_FILL )
		   )

		<< (pane( HORIZONTAL, GREEDY) 
				<< item ( IDC_STATIC_DISPLAY2,	ALIGN_FILL )
		   )

		<< (pane( HORIZONTAL, ABSOLUTE_VERT) 
				<< item ( IDC_BUTTON_START,			ALIGN_FILL )
				<< item ( IDC_BUTTON_STOP,			ALIGN_FILL )
				<< itemFixed( HORIZONTAL,10 )
				<< item ( IDC_STATIC_DISPLAY3,		ALIGN_FILL)
				<< itemFixed( HORIZONTAL, 10 )
				<< ( pane(VERTICAL,ABSOLUTE_HORZ)

						<< item (IDC_EDIT_OFFSET1, ALIGN_FILL)
						<< item (IDC_EDIT_OFFSET2,	ALIGN_FILL)
					)
		   );
	
	UpdateLayout();

	SetDisplayFontSize();

	m_Display1.SetText("----");
	m_Display2.SetText("----");
	m_Display3.SetText("----");

	m_ReceiveWindow1.m_pDisplay = &m_Display1;
	m_ReceiveWindow1.m_pDisto = &m_Disto1;
	m_ReceiveWindow1.m_p2ndValue = &m_ReceiveWindow2;
	m_ReceiveWindow1.m_pDisplayDiff = &m_Display3;
	m_ReceiveWindow1.Create();

	m_ReceiveWindow2.m_pDisplay = &m_Display2;
	m_ReceiveWindow2.m_pDisto = &m_Disto2;
	m_ReceiveWindow2.Create();

	CRegistry aReg;
	CString aString;

	READ_DOUBLE(REGISTRY_DISTO_SUBKEY,KEY_OFFSET1,m_ReceiveWindow1.m_dOffset);
	READ_DOUBLE(REGISTRY_DISTO_SUBKEY,KEY_OFFSET2,m_ReceiveWindow2.m_dOffset);
	
	EnableControls();
	UpdateData(FALSE);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CBigNumberDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CBigNumberDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CBigNumberDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CBigNumberDlg::OnButtonStart() 
{
	StartDisto();
	if(m_bDistoConnected1)	m_Disto1.StartTrackingMeasure();
	if(m_bDistoConnected2)	m_Disto2.StartTrackingMeasure();
}

void CBigNumberDlg::OnButtonStop() 
{
	if(m_bDistoConnected1)	m_Disto1.StopTrackingMeasure();
	if(m_bDistoConnected2)	m_Disto2.StopTrackingMeasure();
}

void CBigNumberDlg::OnSize(UINT nType, int cx, int cy) 
{
	ETSLayoutDialog::OnSize(nType, cx, cy);
	SetDisplayFontSize();
}

void 
CBigNumberDlg::SetDisplayFontSize(int iSize)
{
	if(!iSize)
	{
		CRect aRect;
		m_Display1.GetWindowRect(aRect);

		double iYSize = aRect.Height();
		double iXSize = aRect.Width();

		double k;
		
		k = fabs((iXSize - iYSize)/iXSize);
		TRACE("k: %f iYSize %f iXSize %f",k,iYSize,iXSize);

		iYSize *= k*1.5;

		if(iYSize > aRect.Height()-5) iYSize = aRect.Height()-5;

		if(iYSize > 10)
		{
			m_Display1.SetFontSize((int)iYSize);
			m_Display2.SetFontSize((int)iYSize);
		}
	}
	else
	{
		m_Display1.SetFontSize(iSize);
		m_Display2.SetFontSize(iSize);
	}

	CRect aRect;
	m_Display3.GetWindowRect(aRect);

	double iYSize = aRect.Height();
	double iXSize = aRect.Width();

		double k;
		
	k = fabs((iXSize - iYSize)/iXSize);
	TRACE("k: %f iYSize %f iXSize %f",k,iYSize,iXSize);

	iYSize *= k*1.5;

	if(iYSize > aRect.Height()-5) iYSize = aRect.Height()-5;

	if(iYSize > 10)
	{
		m_Display3.SetFontSize((int)iYSize);
	}
}

//	Ein beliebiges Control enable / disablen
#define EnableCtrl(id)			(GetDlgItem(id)->EnableWindow())
#define DisableCtrl(id)			(GetDlgItem(id)->EnableWindow(0))


void
CBigNumberDlg::EnableControls()
{
	if(m_bDistoConnected1 || m_bDistoConnected2)
	{
		EnableCtrl(IDC_BUTTON_STOP);
	}
	else
	{
		DisableCtrl(IDC_BUTTON_STOP);
	}
}



void CBigNumberDlg::StartDisto()
{
	if(!m_bDistoStart1)
	{
		m_bDistoStart1 = true;

		SetDisplayFontSize(20);

		if(!m_Disto1.CreateDispatch("Disto2.Application"))
		{
			m_Display1.SetText(_T("Kann DISTO online nicht starten"));
		}
		else
		{
			//	Check for DISTOs
			CWaitCursor aWaitCursor;

			m_Display1.SetText(_T("Suche DISTO..."));
			

			Sleep(500);

			m_bDistoConnected1 = m_Disto1.IsDistoConnected(50);

			if(!m_bDistoConnected1)
			{
				m_Display1.SetText(_T("Kein DISTO angeschlossen!"));
			}
			else
			{
				Sleep(500);						//	Disto Seriennummer senden lassen
				HWND hWnd = m_ReceiveWindow1.GetSafeHwnd();

				m_Disto1.SetSendModeToWindow((long)hWnd);
				m_Disto1.SetSendModeUserFormat(_T(" "));
				m_Disto1.SetBvisible(FALSE);
				m_Display1.SetText("");
				SetDisplayFontSize();
			}
		}
	}
	else
	{
		if(!m_bDistoConnected1)
		{
			m_bDistoConnected1 = m_Disto1.FindDisto();

			if(!m_bDistoConnected1)
			{
				SetDisplayFontSize(20);
				m_Display1.SetText(_T("Kein DISTO angeschlossen!"));
			}
		}
	}

	if(!m_bDistoStart2)
	{
		m_bDistoStart2 = true;

		if(!m_Disto2.CreateDispatch("Disto2.Application"))
		{
			m_Display2.SetText(_T("Kann DISTO online nicht starten"));
		}
		else
		{
			//	Check for DISTOs
			CWaitCursor aWaitCursor;

			m_Display2.SetText(_T("Suche DISTO..."));
			

			Sleep(500);

			m_bDistoConnected2 = m_Disto2.IsDistoConnected(50);

			if(!m_bDistoConnected2)
			{
				m_Display2.SetText(_T("Kein DISTO angeschlossen!"));
			}
			else
			{
				Sleep(500);						//	Disto Seriennummer senden lassen
				HWND hWnd = m_ReceiveWindow2.GetSafeHwnd();

				m_Disto2.SetSendModeToWindow((long)hWnd);
				m_Disto2.SetSendModeUserFormat(_T(" "));
				m_Disto2.SetBvisible(FALSE);
				m_Display2.SetText("");
				SetDisplayFontSize();
			}
		}
	}
	else
	{
		if(!m_bDistoConnected2)
		{
			m_bDistoConnected2 = m_Disto2.FindDisto();

			if(!m_bDistoConnected2)
			{
				SetDisplayFontSize(20);
				m_Display2.SetText(_T("Kein DISTO angeschlossen!"));
			}
		}
	}

	EnableControls();
}


void CBigNumberDlg::OnChangeEditOffset1() 
{
	UpdateData(TRUE);
	CRegistry aReg;
	CString aString;
	WRITE_DOUBLE(REGISTRY_DISTO_SUBKEY,KEY_OFFSET1,m_ReceiveWindow1.m_dOffset);
}

void CBigNumberDlg::OnChangeEditOffset2() 
{
	UpdateData(TRUE);
	CRegistry aReg;
	CString aString;
	WRITE_DOUBLE(REGISTRY_DISTO_SUBKEY,KEY_OFFSET2,m_ReceiveWindow2.m_dOffset);
}

void CBigNumberDlg::OnKillfocusEditOffset1() 
{
	UpdateData(FALSE);
}

void CBigNumberDlg::OnKillfocusEditOffset2() 
{
	UpdateData(FALSE);
}

void CBigNumberDlg::OnOK() 
{
	//	NIX machen!
}
